"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _path = require("path");

var _lodash = _interopRequireDefault(require("lodash.pullall"));

var _lodash2 = _interopRequireDefault(require("lodash.uniq"));

var _fs = require("fs");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _default(opts = {}) {
  const dllDir = opts.dllDir,
        api = opts.api,
        include = opts.include,
        exclude = opts.exclude;
  const paths = api.paths,
        _resolveDeps = api._resolveDeps;
  const pkgFile = (0, _path.join)(paths.cwd, 'package.json');
  const pkg = (0, _fs.existsSync)(pkgFile) ? require(pkgFile) : {}; // eslint-disable-line

  const depNames = (0, _lodash.default)((0, _lodash2.default)(Object.keys(pkg.dependencies || {}).concat(include || [])), exclude);

  const webpack = require(_resolveDeps('af-webpack/webpack'));

  const _require = require(_resolveDeps('af-webpack/react-dev-utils')),
        webpackHotDevClientPath = _require.webpackHotDevClientPath;

  const files = (0, _lodash2.default)([...depNames, webpackHotDevClientPath, 'umi/link', 'umi/dynamic', 'umi/navlink', 'umi/redirect', 'umi/router', 'umi/withRouter', 'umi/_renderRoutes', 'umi/_createHistory', 'react', 'react-dom', 'react-router-dom']).sort((a, b) => a > b ? 1 : -1);
  const filesInfoFile = (0, _path.join)(dllDir, 'filesInfo.json');

  if ((0, _fs.existsSync)(filesInfoFile)) {
    if (JSON.parse((0, _fs.readFileSync)(filesInfoFile, 'utf-8')).join(', ') === files.join(', ')) {
      console.log(`[umi-plugin-dll] File list is equal, don't generate the dll file.`);
      return Promise.resolve();
    }
  }

  const afWebpackOpts = api.applyPlugins('modifyAFWebpackOpts', {
    initialValue: {
      cwd: paths.cwd,
      disableBabelTransform: true,
      alias: {},
      babel: {}
    }
  });

  const afWebpackConfig = require(_resolveDeps('af-webpack/getConfig')).default(afWebpackOpts);

  const webpackConfig = _objectSpread({}, afWebpackConfig, {
    entry: {
      umi: files
    },
    output: {
      path: dllDir,
      filename: '[name].dll.js',
      library: '[name]'
    },
    plugins: [...afWebpackConfig.plugins, ...api.webpackConfig.plugins.filter(plugin => {
      return plugin instanceof webpack.DefinePlugin;
    }), new webpack.DllPlugin({
      path: (0, _path.join)(dllDir, '[name].json'),
      name: '[name]',
      context: paths.absSrcPath
    })],
    resolve: _objectSpread({}, afWebpackConfig.resolve, {
      alias: _objectSpread({}, afWebpackConfig.resolve.alias, api.webpackConfig.resolve.alias)
    })
  });

  return new Promise((resolve, reject) => {
    require(_resolveDeps('af-webpack/build')).default({
      webpackConfig,

      onSuccess() {
        console.log('[umi-plugin-dll] Build dll done');
        (0, _fs.writeFileSync)(filesInfoFile, JSON.stringify(files), 'utf-8');
        resolve();
      },

      onFail({
        err
      }) {
        reject(err);
      }

    });
  });
}